#! /bin/perl
#
# $TWSTOOLS/manage_trees_to_browse.pl
#
# mettre a jour le HASH ARRAY des arborescences a traiter
#
# ce script lit le fichier '$TWSTOOLS/list_of_trees_to_browse' "en clair" 
#
# il cree/met a jour le HASH ARRAY '$TWSFILES/list_of_trees.[dir,pag]"
#
#

#
# Eric GARREAU, 1997
# BPL (Bob Public License) : register to the Mailing List of this product
# 'Le Petit Bob' at 'egarreau@free.fr'
#

require 5;
use Fcntl;
use ANYDBM_File;



# la base de l'arborescence Intranet
$TWSROOT=$ENV{"TWSROOT"};
$TWSTOOLS=$ENV{"TWSTOOLS"};
$TWSFILES=$ENV{"TWSFILES"};
die "Variables \$TWS[TOOLS,FILES] non definies --> il faut sourcer '.twsrc'\n" if ($TWSROOT eq '' or $TWSTOOLS eq '' or $TWSFILES eq '');



# le fichier "database" en mode texte
$treesfile="$TWSTOOLS/list_of_trees_to_browse";

# le HASH ARRAY correspondant (temps d'acces plus rapides...)
$treeshash="$TWSFILES/list_of_trees";



# supprimer le HASH, pour ne pas laisser trainer des cadavres...
unlink "$treeshash.dir", "$treeshash.pag";


# ouverture/creation du HASH ARRAY
# 0666 && !umask = masque de creation (066 -> rw-r--r-- si umask = 022)
tie(%trees, 'SDBM_File', $treeshash, O_CREAT | O_RDWR, 0666) or die "(fatal:manage_trees_to_browse:$treeshash)\n";



# la liste de toutes les arborescences a parcourir
open(TREES, "< $treesfile");


while($_ = <TREES>)
{
    chomp;
    next if /^#/;
    next if /^\s*$/;
    
    ($abspath, $equiv, $owner) = split(/\s+/, $_);

    # une petite verification...
    print "manage_trees_to_browse : '$abspath' n'existe pas...\n" if ! -d $abspath;
    next if ! -d $abspath;
    

    # un peu de mise en forme (le VRAI chemin, termine par '/')
    # il FAUT supprimer la reference '/tmp_mnt' si c'est un repertoire qui
    # est servi par 'automount', car un acces sur '/tmp_mnt/HOST' ne
    # declenche PAS le montage, alors que '/HOST' le declenche.. (subtil)
    $abspath = `cd $abspath; /bin/pwd`;
    chomp($abspath);
    $abspath =~ s|^/tmp_mnt||;
    $abspath = "$abspath/";
    $abspath =~ s|//$|/|;


    if($equiv =~ m|exclude|i)
    {
	$trees{$abspath} = 'exclude';
    }
    else
    {
	# une petite mise en forme (chemin termine par '/')
	$equiv = "$equiv/";
	$equiv =~ s|//$||;

	$trees{$abspath} = "$equiv\n$owner";
    }
}


# et ne pas oublier d'ajouter LE PRINCIPAL a cette liste...
# NOTE : le chemin equivalent est VIDE, et c'est volontaire
# (il faut etre relatif par rapport a '$TWSROOT/')
$trees{"$TWSROOT/"} = "\nroot";


close(TREES);
untie(%trees);



